package org.confluence.mod.client.renderer.entity.projectile;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.math.Axis;
import net.minecraft.client.renderer.MultiBufferSource;
import net.minecraft.client.renderer.entity.EntityRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.Mth;
import org.confluence.mod.Confluence;
import org.confluence.mod.client.model.entity.projectile.ThrownKnivesProjectileModel;
import org.confluence.mod.common.entity.projectile.ThrownKnivesProjectile;
import org.confluence.mod.util.ClientUtils;

public class ThrownKnivesProjectileRenderer extends EntityRenderer<ThrownKnivesProjectile> {
    private static final ResourceLocation TEXTURE = Confluence.asResource("textures/entity/thrown_knives_projectile.png");
    private final ThrownKnivesProjectileModel model;

    public ThrownKnivesProjectileRenderer(EntityRendererProvider.Context pContext) {
        super(pContext);
        this.model = new ThrownKnivesProjectileModel(pContext.bakeLayer(ThrownKnivesProjectileModel.LAYER_LOCATION));
    }

    @Override
    public ResourceLocation getTextureLocation(ThrownKnivesProjectile pEntity) {
        return TEXTURE;
    }

    @Override
    public void render(ThrownKnivesProjectile entity, float entityYaw, float partialTick, PoseStack poseStack, MultiBufferSource multiBufferSource, int packedLight) {
        poseStack.pushPose();
        poseStack.translate(0.0F, 0.125F, 0.0F);
        poseStack.mulPose(Axis.YP.rotationDegrees(Mth.lerp(partialTick, entity.yRotO, entity.getYRot()) - 90.0F));
        poseStack.mulPose(Axis.ZP.rotationDegrees(Mth.lerp(partialTick, entity.xRotO, entity.getXRot())));
        poseStack.mulPose(ClientUtils.ANGLE_N90);
        model.renderToBuffer(poseStack, multiBufferSource.getBuffer(model.renderType(TEXTURE)), packedLight, OverlayTexture.NO_OVERLAY);
        poseStack.popPose();
    }
}
