package org.confluence.mod.common.init.item;

import net.minecraft.data.tags.IntrinsicHolderTagsProvider;
import net.minecraft.world.item.Item;
import net.neoforged.neoforge.registries.DeferredRegister;
import org.confluence.mod.Confluence;
import org.confluence.mod.common.data.saved.BrushData;
import org.confluence.mod.common.item.paint.*;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Supplier;

public class PaintItems {
    public static final DeferredRegister.Items ITEMS = DeferredRegister.createItems(Confluence.MODID);
    public static final List<PaintItem> PAINT_ITEMS = new ArrayList<>();

    public static final Supplier<PaintbrushItem> PAINTBRUSH = ITEMS.register("paintbrush", PaintbrushItem::new);
    public static final Supplier<PaintRollerItem> PAINT_ROLLER = ITEMS.register("paint_roller", PaintRollerItem::new);
    public static final Supplier<PaintScraperItem> PAINT_SCRAPER = ITEMS.register("paint_scraper", PaintScraperItem::new);
    public static final Supplier<EyedropperItem> EYEDROPPER = ITEMS.register("eyedropper", EyedropperItem::new);
    public static final Supplier<PaintItem> PAINT = registerPaint("paint", 0x39C5BB);

    public static final Supplier<PaintItem> RED_PAINT = registerPaint("red_paint", 0xdb0909);
    public static final Supplier<PaintItem> DEEP_RED_PAINT = registerPaint("deep_red_paint", 0x55051d);
    public static final Supplier<PaintItem> ORANGE_PAINT = registerPaint("orange_paint", 0xec5a07);
    public static final Supplier<PaintItem> DEEP_ORANGE_PAINT = registerPaint("deep_orange_paint", 0x6f1c03);
    public static final Supplier<PaintItem> YELLOW_PAINT = registerPaint("yellow_paint", 0xf0b007);
    public static final Supplier<PaintItem> DEEP_YELLOW_PAINT = registerPaint("deep_yellow_paint", 0x764403);
    public static final Supplier<PaintItem> LIME_PAINT = registerPaint("lime_paint", 0xb7e013);
    public static final Supplier<PaintItem> DEEP_LIME_PAINT = registerPaint("deep_lime_paint", 0x446e06);
    public static final Supplier<PaintItem> GREEN_PAINT = registerPaint("green_paint", 0x2cdf09);
    public static final Supplier<PaintItem> DEEP_GREEN_PAINT = registerPaint("deep_green_paint", 0x04600a);
    public static final Supplier<PaintItem> TEAL_PAINT = registerPaint("teal_paint", 0x03c75b);
    public static final Supplier<PaintItem> DEEP_TEAL_PAINT = registerPaint("deep_teal_paint", 0x015335);
    public static final Supplier<PaintItem> CYAN_PAINT = registerPaint("cyan_paint", 0x03c7a2);
    public static final Supplier<PaintItem> DEEP_CYAN_PAINT = registerPaint("deep_cyan_paint", 0x045f5e);
    public static final Supplier<PaintItem> SKY_BLUE_PAINT = registerPaint("sky_blue_paint", 0x0699ce);
    public static final Supplier<PaintItem> DEEP_SKY_BLUE_PAINT = registerPaint("deep_sky_blue_paint", 0x053866);
    public static final Supplier<PaintItem> BLUE_PAINT = registerPaint("blue_paint", 0x203ebe);
    public static final Supplier<PaintItem> DEEP_BLUE_PAINT = registerPaint("deep_blue_paint", 0x0b084b);
    public static final Supplier<PaintItem> PURPLE_PAINT = registerPaint("purple_paint", 0x6214d6);
    public static final Supplier<PaintItem> DEEP_PURPLE_PAINT = registerPaint("deep_purple_paint", 0x26126b);
    public static final Supplier<PaintItem> VIOLET_PAINT = registerPaint("violet_paint", 0xba14d6);
    public static final Supplier<PaintItem> DEEP_VIOLET_PAINT = registerPaint("deep_violet_paint", 0x420757);
    public static final Supplier<PaintItem> PINK_PAINT = registerPaint("pink_paint", 0xed10cc);
    public static final Supplier<PaintItem> DEEP_PINK_PAINT = registerPaint("deep_pink_paint", 0x6a095e);
    public static final Supplier<PaintItem> BLACK_PAINT = registerPaint("black_paint", 0x1e1d20);
    public static final Supplier<PaintItem> GRAY_PAINT = registerPaint("gray_paint", 0x676764);
    public static final Supplier<PaintItem> WHITE_PAINT = registerPaint("white_paint", 0xfffef6);
    public static final Supplier<PaintItem> BROWN_PAINT = registerPaint("brown_paint", 0x8b653f);
    public static final Supplier<PaintItem> SHADOW_PAINT = registerPaint("shadow_paint", 0x000000);
    public static final Supplier<PaintItem> NEGATIVE_PAINT = registerPaint("negative_paint", BrushData.NEGATIVE_COLOR);
    public static final Supplier<PaintItem> ILLUMINANT_COATING = registerPaint("illuminant_coating", BrushData.ILLUMINANT_COLOR);
    public static final Supplier<PaintItem> ECHO_COATING = registerPaint("echo_coating", BrushData.ECHO_COLOR); // todo

    private static Supplier<PaintItem> registerPaint(String name, int color) {
        return ITEMS.register(name, () -> {
            PaintItem paintItem = new PaintItem(color);
            PAINT_ITEMS.add(paintItem);
            return paintItem;
        });
    }

    public static void acceptTag(IntrinsicHolderTagsProvider.IntrinsicTagAppender<Item> tag) {
        ITEMS.getEntries().forEach(entry -> tag.add(entry.get()));
    }
}

