package org.confluence.mod.common.item.mana;

import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.EquipmentSlotGroup;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.phys.Vec3;
import org.confluence.mod.common.entity.projectile.HurtnadoProjectile;
import org.confluence.terra_curio.common.component.ModRarity;
import org.confluence.terra_curio.common.init.TCAttributes;
import org.confluence.terra_curio.util.TCUtils;

public class WeatherPainItem extends ManaStaffItem<HurtnadoProjectile> {
    public WeatherPainItem() {
        super(ModRarity.GREEN, HurtnadoProjectile::new, 30, 1.0F, 45, builder -> builder
                .add(TCAttributes.getCriticalChance(), new AttributeModifier(ID, 0.04, AttributeModifier.Operation.ADD_VALUE), EquipmentSlotGroup.MAINHAND)
                .add(TCAttributes.ARMOR_PASS, new AttributeModifier(ID, 10, AttributeModifier.Operation.ADD_VALUE), EquipmentSlotGroup.MAINHAND));
    }

    @Override
    protected void beforeShoot(ServerPlayer player, ItemStack itemStack, HurtnadoProjectile projectile) {
        super.beforeShoot(player, itemStack, projectile);
        projectile.addDeltaMovement(new Vec3(0.0, 0.4, 0.0));
    }

    @Override
    protected void afterShoot(ServerPlayer player, ItemStack itemStack, HurtnadoProjectile projectile) {
        super.afterShoot(player, itemStack, projectile);
        TCUtils.updateItemStackNbt(itemStack, tag -> {
            if (tag.hasUUID("UUID") && player.serverLevel().getEntity(tag.getUUID("UUID")) instanceof HurtnadoProjectile projectile1) {
                projectile1.discard();
            }
            tag.putUUID("UUID", projectile.getUUID());
        });
    }
}
