package org.confluence.mod.mixin.item;

import net.neoforged.neoforge.items.ItemStackHandler;
import org.confluence.mod.util.ModUtils;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(value = ItemStackHandler.class, priority = 1100)
public abstract class ItemStackHandlerMixin {
    @Inject(method = "getSlotLimit", at = @At("RETURN"), cancellable = true)
    private void modify(int slot, CallbackInfoReturnable<Integer> cir) {
        cir.setReturnValue(ModUtils.getMaxStackSize(cir.getReturnValue()));
    }
}
